local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local addon = LibStub("AceAddon-3.0"):NewAddon("Broker2FuBar", "AceConsole-3.0", "AceHook-3.0")

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("Broker2FuBarDB", {
		profile = {
			objects = {
				['*'] = true,
			},
		},
	})
	
	self.fubared = {}

	for name, data_object in ldb:DataObjectIterator() do
		self:FuBarize(name, data_object)
	end

	ldb.RegisterCallback(self, "LibDataBroker_DataObjectCreated")
end

function addon:LibDataBroker_DataObjectCreated(event, name, data_object)
	self:FuBarize(name, data_object)
end

function addon:FuBarize(name, data_object)
	if not self.db.profile.objects[name] then return end
	if self.fubared[name] then return end
	
	local fu = LibStub("AceAddon-3.0"):NewAddon(name .. "_B2Fu", "LibFuBarPlugin-Mod-3.0")
	fu.data_object = data_object

	fu:SetFuBarOption('tooltipType', "GameTooltip")
	
	function fu:OnUpdateFuBarText()
		self:SetFuBarText(data_object.text)
	end
	function fu:OnUpdateFuBarIcon()
		-- this isn't an official fubar method, note
		self:SetFuBarOption('iconPath', data_object.icon)
	end
	function fu:OnFuBarClick(button)
		if data_object.OnClick then
			data_object.OnClick(self:GetPanel(), button)
		end
	end
	function fu:OnUpdateFuBarTooltip()
		if data_object.OnTooltipShow then
			data_object.OnTooltipShow(GameTooltip)
		end
	end
	
	ldb.RegisterCallback(fu, "LibDataBroker_AttributeChanged_"..name.."_text", "OnUpdateFuBarText")
	ldb.RegisterCallback(fu, "LibDataBroker_AttributeChanged_"..name.."_icon", "OnUpdateFuBarIcon")

	fu:OnUpdateFuBarIcon()
	
	self.fubared[name] = fu
end

